import inquirer from 'inquirer';
import InquirerAutocompletePrompt from 'inquirer-autocomplete-prompt';
inquirer.registerPrompt('autocomplete', InquirerAutocompletePrompt);
import fuzzy from 'fuzzy';
export class Form {
    static async run(questions, answers = {}) {
        const formQuestions = questions.filter(q => !q.argumentOnly);
        this.generateAutocompleteSource(formQuestions);
        return await inquirer.prompt(formQuestions, answers);
    }
    static generateAutocompleteSource(questions) {
        questions.filter(o => o.type === 'autocomplete' && o.source === undefined).forEach(o => {
            o.source = async (_, input) => fuzzy.filter(input ?? '', o.choices).map((el) => el.original);
        });
    }
}
