import inquirer from "inquirer";
import { Script } from "./Script";
export interface OptionDefinition extends inquirer.Question<inquirer.Answers> {
    storeDefault?: boolean;
    setupOnce?: boolean;
    argumentOnly?: boolean;
    formOnly?: boolean;
    shorthand?: string;
    value?: string;
}
interface Context {
    store?: UnknownObjectStructure;
}
interface UnknownObjectStructure {
    [key: string]: any;
}
declare type OptionDefinitionGenerator = (store: UnknownObjectStructure, options?: UnknownObjectStructure) => OptionDefinition[];
export interface ScriptDefinition {
    name?: string;
    options?: OptionDefinition[] | OptionDefinitionGenerator;
    store?: UnknownObjectStructure;
    command?(options: OptionDefinition[], context: Context): Promise<any>;
}
export declare class SmartScriptDefinition implements ScriptDefinition {
    name?: string;
    store?: UnknownObjectStructure;
    command?(options: UnknownObjectStructure, context: Context): Promise<any>;
    script: Script;
    removedOptions: string[];
    private optionsSource?;
    constructor(definition: ScriptDefinition, script: Script);
    get options(): OptionDefinition[];
    get setupOnceOptions(): OptionDefinition[];
    get storeDefaultOptions(): OptionDefinition[];
}
export {};
