export class SmartScriptDefinition {
    constructor(definition, script) {
        this.script = script;
        this.name = definition.name;
        this.optionsSource = definition.options;
        this.store = definition.store;
        this.command = definition.command;
        this.removedOptions = [];
    }
    get options() {
        return ((typeof this.optionsSource === 'function')
            ? this.optionsSource(this.script.store, this.script.options)
            : this.optionsSource ?? []);
    }
    get setupOnceOptions() {
        return this.options?.filter(o => o.setupOnce === true);
    }
    get storeDefaultOptions() {
        return this.options?.filter(o => o.storeDefault === true);
    }
}
